libstdc++: std::deque< _Tp, _Alloc > Class Template Reference

libstdc++

std::deque< _Tp, _Alloc > Class Template Reference
Containers » Sequences

`#include <stl_deque.h>`

Inheritance diagram for std::deque< _Tp, _Alloc >:
[legend]

## Public Types
typedef _Alloc | allocator_type
typedef _Base::const_iterator | const_iterator
typedef _Alloc_traits::const_pointer | const_pointer
typedef _Alloc_traits::const_reference | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef ptrdiff_t | difference_type
typedef _Base::iterator | iterator
typedef _Alloc_traits::pointer | pointer
typedef _Alloc_traits::reference | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef size_t | size_type
typedef _Tp | value_type

## Public Member Functions
| deque ()=default
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>
| deque (_InputIterator __first, _InputIterator __last, const allocator_type &__a=allocator_type())
| deque (const allocator_type &__a)
| deque (const deque &__x)
| deque (const deque &__x, const __type_identity_t< allocator_type > &__a)
| deque (deque &&)=default
| deque (deque &&__x, const __type_identity_t< allocator_type > &__a)
| deque (initializer_list< value_type > __l, const allocator_type &__a=allocator_type())
| deque (size_type __n, const allocator_type &__a=allocator_type())
| deque (size_type __n, const value_type &__value, const allocator_type &__a=allocator_type())
| ~deque ()
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>
void | assign (_InputIterator __first, _InputIterator __last)
void | assign (initializer_list< value_type > __l)
void | assign (size_type __n, const value_type &__val)
reference | at (size_type __n)
const_reference | at (size_type __n) const
const_reference | back () const noexcept
reference | back () noexcept
const_iterator | begin () const noexcept
iterator | begin () noexcept
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
void | clear () noexcept
const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crend () const noexcept
template<typename... _Args>
iterator | emplace (const_iterator __position, _Args &&... __args)
template<typename... _Args>
reference | emplace_back (_Args &&... __args)
template<typename... _Args>
reference | emplace_front (_Args &&... __args)
bool | empty () const noexcept
const_iterator | end () const noexcept
iterator | end () noexcept
iterator | erase (const_iterator __first, const_iterator __last)
iterator | erase (const_iterator __position)
const_reference | front () const noexcept
reference | front () noexcept
allocator_type | get_allocator () const noexcept
iterator | insert (const_iterator __p, initializer_list< value_type > __l)
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>
iterator | insert (const_iterator __position, _InputIterator __first, _InputIterator __last)
iterator | insert (const_iterator __position, const value_type &__x)
iterator | insert (const_iterator __position, size_type __n, const value_type &__x)
iterator | insert (const_iterator __position, value_type &&__x)
size_type | max_size () const noexcept
deque & | operator= (const deque &__x)
deque & | operator= (deque &&__x) noexcept(_Alloc_traits::_S_always_equal())
deque & | operator= (initializer_list< value_type > __l)
const_reference | operator[] (size_type __n) const noexcept
reference | operator[] (size_type __n) noexcept
void | pop_back () noexcept
void | pop_front () noexcept
void | push_back (const value_type &__x)
void | push_back (value_type &&__x)
void | push_front (const value_type &__x)
void | push_front (value_type &&__x)
const_reverse_iterator | rbegin () const noexcept
reverse_iterator | rbegin () noexcept
const_reverse_iterator | rend () const noexcept
reverse_iterator | rend () noexcept
void | resize (size_type __new_size)
void | resize (size_type __new_size, const value_type &__x)
void | shrink_to_fit () noexcept
size_type | size () const noexcept
void | swap (deque &__x) noexcept

## Protected Types
enum | { _S_initial_map_size }
typedef __gnu_cxx::__alloc_traits< _Map_alloc_type > | _Map_alloc_traits
typedef _Alloc_traits::template rebind< _Ptr >::other | _Map_alloc_type
typedef _Alloc_traits::pointer | _Ptr
typedef _Alloc_traits::const_pointer | _Ptr_const

## Protected Member Functions
template<typename _ForwardIterator>
void | _M_assign_aux (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
template<typename _InputIterator>
void | _M_assign_aux (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
void | _M_deallocate_map (_Map_pointer __p, size_t __n) noexcept
void | _M_default_append (size_type __n)
void | _M_default_initialize ()
template<typename _Alloc1>
void | _M_destroy_data (iterator __first, iterator __last, const _Alloc1 &)
void | _M_destroy_data (iterator __first, iterator __last, const std::allocator< _Tp > &)
void | _M_destroy_data_aux (iterator __first, iterator __last)
template<typename... _Args>
iterator | _M_emplace_aux (iterator __pos, _Args &&... __args)
iterator | _M_erase (iterator __first, iterator __last)
iterator | _M_erase (iterator __pos)
void | _M_erase_at_begin (iterator __pos)
void | _M_erase_at_end (iterator __pos)
void | _M_fill_assign (size_type __n, const value_type &__val)
void | _M_fill_initialize (const value_type &__value)
void | _M_fill_insert (iterator __pos, size_type __n, const value_type &__x)
_Map_alloc_type | _M_get_map_allocator () const noexcept
template<typename _ForwardIterator>
void | _M_insert_aux (iterator __pos, _ForwardIterator __first, _ForwardIterator __last, size_type __n)
iterator | _M_insert_aux (iterator __pos, const value_type &__x)
void | _M_insert_aux (iterator __pos, size_type __n, const value_type &__x)
void | _M_move_assign1 (deque &&__x, false_type)
void | _M_move_assign1 (deque &&__x, true_type) noexcept
void | _M_move_assign2 (deque &&__x, false_type)
void | _M_move_assign2 (deque &&__x, true_type)
template<typename _InputIterator, typename _Sentinel>
void | _M_range_append (_InputIterator __first, _Sentinel __last, size_type __n)
void | _M_range_check (size_type __n) const
template<typename _ForwardIterator>
void | _M_range_insert_aux (iterator __pos, _ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
template<typename _InputIterator>
void | _M_range_insert_aux (iterator __pos, _InputIterator __first, _InputIterator __last, std::input_iterator_tag)
template<typename _InputIterator, typename _Sentinel>
void | _M_range_prepend (_InputIterator __first, _Sentinel __last, size_type __n)
template<typename... _Args>
void | _M_replace_map (_Args &&... __args)
bool | _M_shrink_to_fit ()
template<typename _InputIterator>
void | _M_range_initialize (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
template<typename _ForwardIterator>
void | _M_range_initialize (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
template<typename... _Args>
void | _M_push_back_aux (_Args &&... __args)
template<typename... _Args>
void | _M_push_front_aux (_Args &&... __args)
void | _M_pop_back_aux ()
void | _M_pop_front_aux ()
iterator | _M_reserve_elements_at_front (size_type __n)
iterator | _M_reserve_elements_at_back (size_type __n)
void | _M_new_elements_at_front (size_type __new_elements)
void | _M_new_elements_at_back (size_type __new_elements)
void | _M_reserve_map_at_back (size_type __nodes_to_add=1)
void | _M_reserve_map_at_front (size_type __nodes_to_add=1)
void | _M_reallocate_map (size_type __nodes_to_add, bool __add_at_front)

## Static Protected Member Functions
static size_t | _S_check_init_len (size_t __n, const allocator_type &__a)
static size_type | _S_max_size (const _Tp_alloc_type &__a) noexcept

## Detailed Description

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
class std::deque< _Tp, _Alloc >

A standard container using fixed-size memory allocation and constant-time manipulation of elements at either end.

Template Parameters

  _Tp | Type of element.
  _Alloc | Allocator type, defaults to allocator<_Tp>.

Meets the requirements of a container, a reversible container, and a sequence, including the optional sequence requirements.

In previous HP/SGI versions of deque, there was an extra template parameter so users could control the node size. This extension turned out to violate the C++ standard (it can be detected using template template parameters), and it was removed.

Here's how a deque<Tp> manages memory. Each deque has 4 members:

- Tp** _M_map
- size_t _M_map_size
- iterator _M_start, _M_finish

map_size is at least 8. map is an array of map_size pointers-to-nodes. (The name map has nothing to do with the std::map class, and nodes should not be confused with std::list's usage of node.)

A node has no specific type name as such, but it is referred to as node in this file. It is a simple array-of-Tp. If Tp is very large, there will be one Tp element per node (i.e., an array of one). For non-huge Tp's, node size is inversely related to Tp size: the larger the Tp, the fewer Tp's will fit in a node. The goal here is to keep the total size of a node relatively small and constant over different Tp's, to improve allocator efficiency.

Not every pointer in the map array will point to a node. If the initial number of elements in the deque is small, the /middle/ map pointers will be valid, and the ones at the edges will be unused. This same situation will arise as the map grows: available map pointers, if any, will be on the ends. As new nodes are created, only a subset of the map's pointers need to be copied outward.

Class invariants:

- For any nonsingular iterator i:
  - i.node points to a member of the map array. (Yes, you read that correctly: i.node does not actually point to a node.) The member of the map array is what actually points to the node.
  - i.first == *(i.node) (This points to the node (first Tp element).)
  - i.last == i.first + node_size
  - i.cur is a pointer in the range [i.first, i.last). NOTE: the implication of this is that i.cur is always a dereferenceable pointer, even if i is a past-the-end iterator.
- Start and Finish are always nonsingular iterators. NOTE: this means that an empty deque must have one node, a deque with <N elements (where N is the node buffer size) must have one node, a deque with N through (2N-1) elements must have two nodes, etc.
- For every node other than start.node and finish.node, every element in the node is an initialized object. If start.node == finish.node, then [start.cur, finish.cur) are initialized objects, and the elements outside that range are uninitialized storage. Otherwise, [start.cur, start.last) and [finish.first, finish.cur) are initialized objects, and [start.first, start.cur) and [finish.cur, finish.last) are uninitialized storage.
- [map, map + map_size) is a valid, non-empty range.
- [start.node, finish.node] is a valid range contained within [map, map + map_size).

- A pointer in the range [map, map + map_size) points to an allocated node if and only if the pointer is in the range [start.node, finish.node].

  Here's the magic: nothing in deque is aware of the discontiguous storage!

  The memory setup and layout occurs in the parent, _Base, and the iterator class is entirely responsible for leaping from one node to the next. All the implementation routines for deque itself work only through the start and finish iterators. This keeps the routines simple and sane, and we can use other standard algorithms as well.

Definition at line 790 of file stl_deque.h.

## Member Typedef Documentation

## ◆ _Map_alloc_traits

template<typename _Tp, typename _Alloc>

typedef __gnu_cxx::__alloc_traits<_Map_alloc_type> std::_Deque_base< _Tp, _Alloc >::_Map_alloc_traits
| protectedinherited

Definition at line 450 of file stl_deque.h.

## ◆ _Map_alloc_type

template<typename _Tp, typename _Alloc>

typedef _Alloc_traits::template rebind<_Ptr>::other std::_Deque_base< _Tp, _Alloc >::_Map_alloc_type
| protectedinherited

Definition at line 449 of file stl_deque.h.

## ◆ _Ptr

template<typename _Tp, typename _Alloc>

typedef _Alloc_traits::pointer std::_Deque_base< _Tp, _Alloc >::_Ptr
| protectedinherited

Definition at line 444 of file stl_deque.h.

## ◆ _Ptr_const

template<typename _Tp, typename _Alloc>

typedef _Alloc_traits::const_pointer std::_Deque_base< _Tp, _Alloc >::_Ptr_const
| protectedinherited

Definition at line 445 of file stl_deque.h.

## ◆ allocator_type

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Alloc std::deque< _Tp, _Alloc >::allocator_type

Definition at line 827 of file stl_deque.h.

## ◆ const_iterator

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Base::const_iterator std::deque< _Tp, _Alloc >::const_iterator

Definition at line 822 of file stl_deque.h.

## ◆ const_pointer

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Alloc_traits::const_pointer std::deque< _Tp, _Alloc >::const_pointer

Definition at line 818 of file stl_deque.h.

## ◆ const_reference

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Alloc_traits::const_reference std::deque< _Tp, _Alloc >::const_reference

Definition at line 820 of file stl_deque.h.

## ◆ const_reverse_iterator

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef std::reverse_iterator<const_iterator> std::deque< _Tp, _Alloc >::const_reverse_iterator

Definition at line 823 of file stl_deque.h.

## ◆ difference_type

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef ptrdiff_t std::deque< _Tp, _Alloc >::difference_type

Definition at line 826 of file stl_deque.h.

## ◆ iterator

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Base::iterator std::deque< _Tp, _Alloc >::iterator

Definition at line 821 of file stl_deque.h.

## ◆ pointer

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Alloc_traits::pointer std::deque< _Tp, _Alloc >::pointer

Definition at line 817 of file stl_deque.h.

## ◆ reference

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Alloc_traits::reference std::deque< _Tp, _Alloc >::reference

Definition at line 819 of file stl_deque.h.

## ◆ reverse_iterator

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef std::reverse_iterator<iterator> std::deque< _Tp, _Alloc >::reverse_iterator

Definition at line 824 of file stl_deque.h.

## ◆ size_type

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef size_t std::deque< _Tp, _Alloc >::size_type

Definition at line 825 of file stl_deque.h.

## ◆ value_type

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

typedef _Tp std::deque< _Tp, _Alloc >::value_type

Definition at line 816 of file stl_deque.h.

## Member Enumeration Documentation

## ◆ anonymous enum

template<typename _Tp, typename _Alloc>

anonymous enum
| protectedinherited

Definition at line 614 of file stl_deque.h.

## Constructor & Destructor Documentation

## ◆ deque() [1/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( |  | ) |
| default

Creates a deque with no elements.

Referenced by insert(), and operator=().

## ◆ deque() [2/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | const allocator_type & | __a | ) |
| inlineexplicit

Creates a deque with no elements.

Parameters

  __a | An allocator object.

Definition at line 867 of file stl_deque.h.

## ◆ deque() [3/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | size_type | __n,
|  | const allocator_type & | __a = allocator_type() )
| inlineexplicit

Creates a deque with default constructed elements.

Parameters

  __n | The number of elements to initially create.
  __a | An allocator.

This constructor fills the deque with n default constructed elements.

Definition at line 880 of file stl_deque.h.

## ◆ deque() [4/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | size_type | __n,
|  | const value_type & | __value,
|  | const allocator_type & | __a = allocator_type() )
| inline

Creates a deque with copies of an exemplar element.

Parameters

  __n | The number of elements to initially create.
  __value | An element to copy.
  __a | An allocator.

This constructor fills the deque with __n copies of __value.

Definition at line 892 of file stl_deque.h.

## ◆ deque() [5/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | const deque< _Tp, _Alloc > & | __x | ) |
| inline

Deque copy constructor.

Parameters

  __x | A deque of identical element and allocator types.

The newly-created deque uses a copy of the allocator object used by __x (unless the allocator traits dictate a different object).

Definition at line 919 of file stl_deque.h.

## ◆ deque() [6/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | deque< _Tp, _Alloc > && |  | ) |
| default

Deque move constructor.

The newly-created deque contains the exact contents of the moved instance. The contents of the moved instance are a valid, but unspecified deque.

## ◆ deque() [7/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | const deque< _Tp, _Alloc > & | __x,
|  | const __type_identity_t< allocator_type > & | __a )
| inline

Copy constructor with alternative allocator.

Definition at line 938 of file stl_deque.h.

## ◆ deque() [8/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | deque< _Tp, _Alloc > && | __x,
|  | const __type_identity_t< allocator_type > & | __a )
| inline

Move constructor with alternative allocator.

Definition at line 945 of file stl_deque.h.

## ◆ deque() [9/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | initializer_list< value_type > | __l,
|  | const allocator_type & | __a = allocator_type() )
| inline

Builds a deque from an initializer list.

Parameters

  __l | An initializer_list.
  __a | An allocator object.

Create a deque consisting of copies of the elements in the initializer_list __l.

This will call the element type's copy constructor N times (where N is __l.size()) and do no memory reallocation.

Definition at line 978 of file stl_deque.h.

## ◆ deque() [10/10]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>

std::deque< _Tp, _Alloc >::deque | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const allocator_type & | __a = allocator_type() )
| inline

Builds a deque from a range.

Parameters

  __first | An input iterator.
  __last | An input iterator.
  __a | An allocator object.

Create a deque consisting of copies of the elements from [__first, __last).

If the iterators are forward, bidirectional, or random-access, then this will call the elements' copy constructor N times (where N is distance(__first,__last)) and do no memory reallocation. But if only input iterators are used, then this will do at most 2N calls to the copy constructor, and logN memory reallocations.

Definition at line 1005 of file stl_deque.h.

## ◆ ~deque()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::~deque | ( |  | ) |
| inline

The dtor only erases the elements, and note that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1041 of file stl_deque.h.

## Member Function Documentation

## ◆ _M_assign_aux() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _ForwardIterator>

void std::deque< _Tp, _Alloc >::_M_assign_aux | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | std::forward_iterator_tag | )
| inlineprotected

Definition at line 2052 of file stl_deque.h.

## ◆ _M_assign_aux() [2/2]

template<typename _Tp, class _Alloc>
template<typename _InputIterator>

void deque::_M_assign_aux | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | std::input_iterator_tag | )
| protected

Definition at line 291 of file deque.tcc.

## ◆ _M_deallocate_map()

template<typename _Tp, typename _Alloc>

void std::_Deque_base< _Tp, _Alloc >::_M_deallocate_map | ( | _Map_pointer | __p,
|  | size_t | __n )
| inlineprotectednoexceptinherited

Definition at line 604 of file stl_deque.h.

## ◆ _M_default_append()

template<typename _Tp, typename _Alloc>

void deque::_M_default_append | ( | size_type | __n | ) |
| protected

Definition at line 350 of file deque.tcc.

## ◆ _M_default_initialize()

template<typename _Tp, typename _Alloc>

void deque::_M_default_initialize | ( |  | ) |
| protected

Definition at line 69 of file deque.tcc.

## ◆ _M_destroy_data() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _Alloc1>

void std::deque< _Tp, _Alloc >::_M_destroy_data | ( | iterator | __first,
|  | iterator | __last,
|  | const _Alloc1 & | )
| inlineprotected

Definition at line 2222 of file stl_deque.h.

## ◆ _M_destroy_data() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_destroy_data | ( | iterator | __first,
|  | iterator | __last,
|  | const std::allocator< _Tp > & | )
| inlineprotected

Definition at line 2226 of file stl_deque.h.

## ◆ _M_destroy_data_aux()

template<typename _Tp, typename _Alloc>

void deque::_M_destroy_data_aux | ( | iterator | __first,
|  | iterator | __last )
| protected

Definition at line 1036 of file deque.tcc.

## ◆ _M_emplace_aux()

template<typename _Tp, typename _Alloc>
template<typename... _Args>

deque< _Tp, _Alloc >::iterator deque::_M_emplace_aux | ( | iterator | __pos,
|  | _Args &&... | __args )
| protected

Definition at line 664 of file deque.tcc.

## ◆ _M_erase() [1/2]

template<typename _Tp, typename _Alloc>

deque< _Tp, _Alloc >::iterator deque::_M_erase | ( | iterator | __first,
|  | iterator | __last )
| protected

Definition at line 258 of file deque.tcc.

## ◆ _M_erase() [2/2]

template<typename _Tp, typename _Alloc>

deque< _Tp, _Alloc >::iterator deque::_M_erase | ( | iterator | __pos | ) |
| protected

Definition at line 235 of file deque.tcc.

## ◆ _M_erase_at_begin()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_erase_at_begin | ( | iterator | __pos | ) |
| inlineprotected

Definition at line 2235 of file stl_deque.h.

## ◆ _M_erase_at_end()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_erase_at_end | ( | iterator | __pos | ) |
| inlineprotected

Definition at line 2245 of file stl_deque.h.

## ◆ _M_fill_assign()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_fill_assign | ( | size_type | __n,
|  | const value_type & | __val )
| inlineprotected

Definition at line 2071 of file stl_deque.h.

## ◆ _M_fill_initialize()

template<typename _Tp, typename _Alloc>

void deque::_M_fill_initialize | ( | const value_type & | __value | ) |
| protected

Fills the deque with copies of value.

Parameters

  __value | Initial value.

Precondition
  _M_start and _M_finish have already been initialized, but none of the deque's elements have yet been constructed.

This function is called only when the user provides an explicit size (with or without an explicit exemplar value).

Definition at line 393 of file deque.tcc.

References std::_Destroy().

Referenced by std::deque< _Tp, polymorphic_allocator< _Tp > >::deque().

## ◆ _M_fill_insert()

template<typename _Tp, typename _Alloc>

void deque::_M_fill_insert | ( | iterator | __pos,
|  | size_type | __n,
|  | const value_type & | __x )
| protected

Definition at line 307 of file deque.tcc.

## ◆ _M_get_map_allocator()

template<typename _Tp, typename _Alloc>

_Map_alloc_type std::_Deque_base< _Tp, _Alloc >::_M_get_map_allocator | ( |  | ) | const
| inlineprotectednoexceptinherited

Definition at line 579 of file stl_deque.h.

## ◆ _M_insert_aux() [1/3]

template<typename _Tp, typename _Alloc>
template<typename _ForwardIterator>

void deque::_M_insert_aux | ( | iterator | __pos,
|  | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | size_type | __n )
| protected

Definition at line 797 of file deque.tcc.

## ◆ _M_insert_aux() [2/3]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::_M_insert_aux | ( | iterator | __pos,
|  | const value_type & | __x )
| inlineprotected

Definition at line 2193 of file stl_deque.h.

## ◆ _M_insert_aux() [3/3]

template<typename _Tp, typename _Alloc>

void deque::_M_insert_aux | ( | iterator | __pos,
|  | size_type | __n,
|  | const value_type & | __x )
| protected

Definition at line 711 of file deque.tcc.

## ◆ _M_move_assign1() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_move_assign1 | ( | deque< _Tp, _Alloc > && | __x,
|  | false_type | )
| inlineprotected

Definition at line 2341 of file stl_deque.h.

## ◆ _M_move_assign1() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_move_assign1 | ( | deque< _Tp, _Alloc > && | __x,
|  | true_type | )
| inlineprotectednoexcept

Definition at line 2330 of file stl_deque.h.

## ◆ _M_move_assign2() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_move_assign2 | ( | deque< _Tp, _Alloc > && | __x,
|  | false_type | )
| inlineprotected

Definition at line 2385 of file stl_deque.h.

## ◆ _M_move_assign2() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_move_assign2 | ( | deque< _Tp, _Alloc > && | __x,
|  | true_type | )
| inlineprotected

Definition at line 2371 of file stl_deque.h.

## ◆ _M_new_elements_at_back()

template<typename _Tp, typename _Alloc>

void deque::_M_new_elements_at_back | ( | size_type | __new_elements | ) |
| protected

Memory-handling helpers for the previous internal insert functions.

Definition at line 1083 of file deque.tcc.

References _M_reserve_map_at_back(), max_size(), and std::size().

Referenced by std::deque< _Tp, polymorphic_allocator< _Tp > >::_M_reserve_elements_at_back().

## ◆ _M_new_elements_at_front()

template<typename _Tp, typename _Alloc>

void deque::_M_new_elements_at_front | ( | size_type | __new_elements | ) |
| protected

Memory-handling helpers for the previous internal insert functions.

Definition at line 1058 of file deque.tcc.

References _M_reserve_map_at_front(), max_size(), and std::size().

Referenced by std::deque< _Tp, polymorphic_allocator< _Tp > >::_M_reserve_elements_at_front().

## ◆ _M_pop_back_aux()

template<typename _Tp, typename _Alloc>

void deque::_M_pop_back_aux | ( |  | ) |
| protected

Helper functions for push_* and pop_*.

Definition at line 560 of file deque.tcc.

Referenced by std::deque< _Tp, polymorphic_allocator< _Tp > >::pop_back().

## ◆ _M_pop_front_aux()

template<typename _Tp, typename _Alloc>

void deque::_M_pop_front_aux | ( |  | ) |
| protected

Helper functions for push_* and pop_*.

Definition at line 576 of file deque.tcc.

Referenced by std::deque< _Tp, polymorphic_allocator< _Tp > >::pop_front().

## ◆ _M_push_back_aux()

template<typename _Tp, typename _Alloc>
template<typename... _Args>

void deque::_M_push_back_aux | ( | _Args &&... | __args | ) |
| protected

Helper functions for push_* and pop_*.

Definition at line 484 of file deque.tcc.

References _M_reserve_map_at_back(), std::forward(), max_size(), and std::size().

Referenced by std::deque< _Tp, polymorphic_allocator< _Tp > >::push_back().

## ◆ _M_push_front_aux()

template<typename _Tp, typename _Alloc>
template<typename... _Args>

void deque::_M_push_front_aux | ( | _Args &&... | __args | ) |
| protected

Helper functions for push_* and pop_*.

Definition at line 523 of file deque.tcc.

References _M_reserve_map_at_front(), std::forward(), max_size(), and std::size().

Referenced by std::deque< _Tp, polymorphic_allocator< _Tp > >::push_front().

## ◆ _M_range_append()

template<typename _Tp, typename _Alloc>
template<typename _InputIterator, typename _Sentinel>

void deque::_M_range_append | ( | _InputIterator | __first,
|  | _Sentinel | __last,
|  | size_type | __n )
| protected

Definition at line 611 of file deque.tcc.

## ◆ _M_range_check()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_range_check | ( | size_type | __n | ) | const
| inlineprotected

Safety check used only from at().

Definition at line 1458 of file stl_deque.h.

Referenced by std::deque< _Tp, polymorphic_allocator< _Tp > >::at(), and std::deque< _Tp, polymorphic_allocator< _Tp > >::at().

## ◆ _M_range_initialize() [1/2]

template<typename _Tp, typename _Alloc>
template<typename _ForwardIterator>

void deque::_M_range_initialize | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | std::forward_iterator_tag | )
| protected

Fills the deque with whatever is in [first,last).

Parameters

  __first | An input iterator.
  __last | An input iterator.

If the iterators are actually forward iterators (or better), then the memory layout can be done all at once. Else we move forward using push_back on each value from the iterator.

Definition at line 443 of file deque.tcc.

References std::_Destroy(), std::advance(), and std::distance().

## ◆ _M_range_initialize() [2/2]

template<typename _Tp, typename _Alloc>
template<typename _InputIterator>

void deque::_M_range_initialize | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | std::input_iterator_tag | )
| protected

Fills the deque with whatever is in [first,last).

Parameters

  __first | An input iterator.
  __last | An input iterator.

If the iterators are actually forward iterators (or better), then the memory layout can be done all at once. Else we move forward using push_back on each value from the iterator.

Definition at line 419 of file deque.tcc.

References clear(), and push_back().

Referenced by std::deque< _Tp, polymorphic_allocator< _Tp > >::deque(), and std::deque< _Tp, polymorphic_allocator< _Tp > >::deque().

## ◆ _M_range_insert_aux() [1/2]

template<typename _Tp, typename _Alloc>
template<typename _ForwardIterator>

void deque::_M_range_insert_aux | ( | iterator | __pos,
|  | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | std::forward_iterator_tag | )
| protected

Definition at line 643 of file deque.tcc.

## ◆ _M_range_insert_aux() [2/2]

template<typename _Tp, typename _Alloc>
template<typename _InputIterator>

void deque::_M_range_insert_aux | ( | iterator | __pos,
|  | _InputIterator | __first,
|  | _InputIterator | __last,
|  | std::input_iterator_tag | )
| protected

Definition at line 634 of file deque.tcc.

## ◆ _M_range_prepend()

template<typename _Tp, typename _Alloc>
template<typename _InputIterator, typename _Sentinel>

void deque::_M_range_prepend | ( | _InputIterator | __first,
|  | _Sentinel | __last,
|  | size_type | __n )
| protected

Definition at line 589 of file deque.tcc.

## ◆ _M_reallocate_map()

template<typename _Tp, typename _Alloc>

void deque::_M_reallocate_map | ( | size_type | __nodes_to_add,
|  | bool | __add_at_front )
| protected

Memory-handling helpers for the major map.

Makes sure the _M_map has space for new nodes. Does not actually add the nodes. Can invalidate _M_map pointers. (And consequently, deque iterators.)

Definition at line 1108 of file deque.tcc.

References std::max(), and max_size().

Referenced by std::deque< _Tp, polymorphic_allocator< _Tp > >::_M_reserve_map_at_back(), and std::deque< _Tp, polymorphic_allocator< _Tp > >::_M_reserve_map_at_front().

## ◆ _M_replace_map()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename... _Args>

void std::deque< _Tp, _Alloc >::_M_replace_map | ( | _Args &&... | __args | ) |
| inlineprotected

Definition at line 2355 of file stl_deque.h.

## ◆ _M_reserve_elements_at_back()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::_M_reserve_elements_at_back | ( | size_type | __n | ) |
| inlineprotected

Memory-handling helpers for the previous internal insert functions.

Definition at line 2281 of file stl_deque.h.

## ◆ _M_reserve_elements_at_front()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::_M_reserve_elements_at_front | ( | size_type | __n | ) |
| inlineprotected

Memory-handling helpers for the previous internal insert functions.

Definition at line 2271 of file stl_deque.h.

## ◆ _M_reserve_map_at_back()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_reserve_map_at_back | ( | size_type | __nodes_to_add = 1 | ) |
| inlineprotected

Memory-handling helpers for the major map.

Makes sure the _M_map has space for new nodes. Does not actually add the nodes. Can invalidate _M_map pointers. (And consequently, deque iterators.)

Definition at line 2307 of file stl_deque.h.

Referenced by _M_new_elements_at_back(), and _M_push_back_aux().

## ◆ _M_reserve_map_at_front()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_reserve_map_at_front | ( | size_type | __nodes_to_add = 1 | ) |
| inlineprotected

Memory-handling helpers for the major map.

Makes sure the _M_map has space for new nodes. Does not actually add the nodes. Can invalidate _M_map pointers. (And consequently, deque iterators.)

Definition at line 2315 of file stl_deque.h.

Referenced by _M_new_elements_at_front(), and _M_push_front_aux().

## ◆ _M_shrink_to_fit()

template<typename _Tp, typename _Alloc>

bool deque::_M_shrink_to_fit | ( |  | ) |
| protected

Definition at line 374 of file deque.tcc.

## ◆ _S_check_init_len()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_t std::deque< _Tp, _Alloc >::_S_check_init_len | ( | size_t | __n,
|  | const allocator_type & | __a )
| inlinestaticprotected

Definition at line 1965 of file stl_deque.h.

## ◆ _S_max_size()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_type std::deque< _Tp, _Alloc >::_S_max_size | ( | const _Tp_alloc_type & | __a | ) |
| inlinestaticprotectednoexcept

Definition at line 1974 of file stl_deque.h.

## ◆ assign() [1/3]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>

void std::deque< _Tp, _Alloc >::assign | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inline

Assigns a range to a deque.

Parameters

  __first | An input iterator.
  __last | An input iterator.

This function fills a deque with copies of the elements in the range [__first,__last).

Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned.

Definition at line 1123 of file stl_deque.h.

## ◆ assign() [2/3]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::assign | ( | initializer_list< value_type > | __l | ) |
| inline

Assigns an initializer list to a deque.

Parameters

  __l | An initializer_list.

This function fills a deque with copies of the elements in the initializer_list __l.

Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned.

Definition at line 1148 of file stl_deque.h.

## ◆ assign() [3/3]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::assign | ( | size_type | __n,
|  | const value_type & | __val )
| inline

Assigns a given value to a deque.

Parameters

  __n | Number of elements to be assigned.
  __val | Value to be assigned.

This function fills a deque with n copies of the given value. Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned.

Definition at line 1104 of file stl_deque.h.

## ◆ at() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::deque< _Tp, _Alloc >::at | ( | size_type | __n | ) |
| inline

Provides access to the data contained in the deque.

Parameters

  __n | The index of the element for which data should be accessed.

Returns
  Read/write reference to data.

Exceptions

  std::out_of_range | If __n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the deque. The function throws out_of_range if the check fails.

Definition at line 1480 of file stl_deque.h.

## ◆ at() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::deque< _Tp, _Alloc >::at | ( | size_type | __n | ) | const
| inline

Provides access to the data contained in the deque.

Parameters

  __n | The index of the element for which data should be accessed.

Returns
  Read-only (constant) reference to data.

Exceptions

  std::out_of_range | If __n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the deque. The function throws out_of_range if the check fails.

Definition at line 1498 of file stl_deque.h.

## ◆ back() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::deque< _Tp, _Alloc >::back | ( |  | ) | const
| inlinenodiscardnoexcept

Returns a read-only (constant) reference to the data at the last element of the deque.

Definition at line 1548 of file stl_deque.h.

## ◆ back() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::deque< _Tp, _Alloc >::back | ( |  | ) |
| inlinenodiscardnoexcept

Returns a read/write reference to the data at the last element of the deque.

Definition at line 1534 of file stl_deque.h.

## ◆ begin() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::deque< _Tp, _Alloc >::begin | ( |  | ) | const
| inlinenodiscardnoexcept

Returns a read-only (constant) iterator that points to the first element in the deque. Iteration is done in ordinary element order.

Definition at line 1221 of file stl_deque.h.

## ◆ begin() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::begin | ( |  | ) |
| inlinenodiscardnoexcept

Returns a read/write iterator that points to the first element in the deque. Iteration is done in ordinary element order.

Definition at line 1212 of file stl_deque.h.

Referenced by std::deque< _Tp, polymorphic_allocator< _Tp > >::deque(), std::deque< _Tp, polymorphic_allocator< _Tp > >::deque(), std::deque< _Tp, polymorphic_allocator< _Tp > >::~deque(), std::deque< _Tp, polymorphic_allocator< _Tp > >::clear(), std::deque< _Tp, polymorphic_allocator< _Tp > >::front(), std::deque< _Tp, polymorphic_allocator< _Tp > >::front(), std::deque< _Tp, polymorphic_allocator< _Tp > >::insert(), std::deque< _Tp, polymorphic_allocator< _Tp > >::insert(), std::deque< _Tp, polymorphic_allocator< _Tp > >::insert(), std::operator<=>(), and operator=().

## ◆ cbegin()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::deque< _Tp, _Alloc >::cbegin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points to the first element in the deque. Iteration is done in ordinary element order.

Definition at line 1291 of file stl_deque.h.

Referenced by std::deque< _Tp, polymorphic_allocator< _Tp > >::insert(), std::deque< _Tp, polymorphic_allocator< _Tp > >::insert(), and std::deque< _Tp, polymorphic_allocator< _Tp > >::insert().

## ◆ cend()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::deque< _Tp, _Alloc >::cend | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points one past the last element in the deque. Iteration is done in ordinary element order.

Definition at line 1301 of file stl_deque.h.

## ◆ clear()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::clear | ( |  | ) |
| inlinenoexcept

Erases all the elements. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1933 of file stl_deque.h.

Referenced by _M_range_initialize().

## ◆ crbegin()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::deque< _Tp, _Alloc >::crbegin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reverse iterator that points to the last element in the deque. Iteration is done in reverse element order.

Definition at line 1311 of file stl_deque.h.

## ◆ crend()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::deque< _Tp, _Alloc >::crend | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order.

Definition at line 1321 of file stl_deque.h.

## ◆ emplace()

template<typename _Tp, typename _Alloc>
template<typename... _Args>

deque< _Tp, _Alloc >::iterator deque::emplace | ( | const_iterator | __position,
|  | _Args &&... | __args )

Inserts an object in deque before specified iterator.

Parameters

  __position | A const_iterator into the deque.
  __args | Arguments.

Returns
  An iterator that points to the inserted data.

This function will insert an object of type T constructed with T(std::forward<Args>(args)...) before the specified location.

Definition at line 187 of file deque.tcc.

References std::forward().

Referenced by std::deque< _Tp, polymorphic_allocator< _Tp > >::insert().

## ◆ emplace_back()

template<typename _Tp, typename _Alloc>
template<typename... _Args>

deque< _Tp, _Alloc >::reference deque::emplace_back | ( | _Args &&... | __args | ) |

Definition at line 164 of file deque.tcc.

## ◆ emplace_front()

template<typename _Tp, typename _Alloc>
template<typename... _Args>

deque< _Tp, _Alloc >::reference deque::emplace_front | ( | _Args &&... | __args | ) |

Definition at line 140 of file deque.tcc.

## ◆ empty()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

bool std::deque< _Tp, _Alloc >::empty | ( |  | ) | const
| inlinenodiscardnoexcept

Returns true if the deque is empty. (Thus begin() would equal end().)

Definition at line 1413 of file stl_deque.h.

## ◆ end() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::deque< _Tp, _Alloc >::end | ( |  | ) | const
| inlinenodiscardnoexcept

Returns a read-only (constant) iterator that points one past the last element in the deque. Iteration is done in ordinary element order.

Definition at line 1241 of file stl_deque.h.

## ◆ end() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::end | ( |  | ) |
| inlinenodiscardnoexcept

Returns a read/write iterator that points one past the last element in the deque. Iteration is done in ordinary element order.

Definition at line 1231 of file stl_deque.h.

Referenced by std::deque< _Tp, polymorphic_allocator< _Tp > >::deque(), std::deque< _Tp, polymorphic_allocator< _Tp > >::deque(), std::deque< _Tp, polymorphic_allocator< _Tp > >::~deque(), std::deque< _Tp, polymorphic_allocator< _Tp > >::back(), std::deque< _Tp, polymorphic_allocator< _Tp > >::back(), std::operator<=>(), and operator=().

## ◆ erase() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::erase | ( | const_iterator | __first,
|  | const_iterator | __last )
| inline

Remove a range of elements.

Parameters

  __first | Iterator pointing to the first element to be erased.
  __last | Iterator pointing to one past the last element to be erased.

Returns
  An iterator pointing to the element pointed to by last prior to erasing (or end()).

This function will erase the elements in the range [__first,__last) and shorten the deque accordingly.

The user is cautioned that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1897 of file stl_deque.h.

## ◆ erase() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::erase | ( | const_iterator | __position | ) |
| inline

Remove element at given position.

Parameters

  __position | Iterator pointing to element to be erased.

Returns
  An iterator pointing to the next element (or end()).

This function will erase the element at the given position and thus shorten the deque by one.

The user is cautioned that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1873 of file stl_deque.h.

## ◆ front() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::deque< _Tp, _Alloc >::front | ( |  | ) | const
| inlinenodiscardnoexcept

Returns a read-only (constant) reference to the data at the first element of the deque.

Definition at line 1522 of file stl_deque.h.

## ◆ front() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::deque< _Tp, _Alloc >::front | ( |  | ) |
| inlinenodiscardnoexcept

Returns a read/write reference to the data at the first element of the deque.

Definition at line 1510 of file stl_deque.h.

## ◆ get_allocator()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

allocator_type std::deque< _Tp, _Alloc >::get_allocator | ( |  | ) | const
| inlinenodiscardnoexcept

Get a copy of the memory allocation object.

Definition at line 1202 of file stl_deque.h.

Referenced by operator=().

## ◆ insert() [1/5]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::insert | ( | const_iterator | __p,
|  | initializer_list< value_type > | __l )
| inline

Inserts an initializer list into the deque.

Parameters

  __p | An iterator into the deque.
  __l | An initializer_list.

Returns
  An iterator that points to the inserted data.

This function will insert copies of the data in the initializer_list __l into the deque before the location specified by __p. This is known as list insert.

Definition at line 1741 of file stl_deque.h.

## ◆ insert() [2/5]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>

iterator std::deque< _Tp, _Alloc >::insert | ( | const_iterator | __position,
|  | _InputIterator | __first,
|  | _InputIterator | __last )
| inline

Inserts a range into the deque.

Parameters

  __position | A const_iterator into the deque.
  __first | An input iterator.
  __last | An input iterator.

Returns
  An iterator that points to the inserted data.

This function will insert copies of the data in the range [__first,__last) into the deque before the location specified by __position. This is known as range insert.

Definition at line 1796 of file stl_deque.h.

## ◆ insert() [3/5]

template<typename _Tp, typename _Alloc>

deque< _Tp, _Alloc >::iterator deque::insert | ( | const_iterator | __position,
|  | const value_type & | __x )

Inserts given value into deque before specified iterator.

Parameters

  __position | A const_iterator into the deque.
  __x | Data to be inserted.

Returns
  An iterator that points to the inserted data.

This function will insert a copy of the given value before the specified location.

Definition at line 210 of file deque.tcc.

References deque(), insert(), push_back(), and push_front().

Referenced by insert().

## ◆ insert() [4/5]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::insert | ( | const_iterator | __position,
|  | size_type | __n,
|  | const value_type & | __x )
| inline

Inserts a number of copies of given data into the deque.

Parameters

  __position | A const_iterator into the deque.
  __n | Number of elements to be inserted.
  __x | Data to be inserted.

Returns
  An iterator that points to the inserted data.

This function will insert a specified number of copies of the given data before the location specified by __position.

Definition at line 1760 of file stl_deque.h.

## ◆ insert() [5/5]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::insert | ( | const_iterator | __position,
|  | value_type && | __x )
| inline

Inserts given rvalue into deque before specified iterator.

Parameters

  __position | A const_iterator into the deque.
  __x | Data to be inserted.

Returns
  An iterator that points to the inserted data.

This function will insert a copy of the given rvalue before the specified location.

Definition at line 1727 of file stl_deque.h.

## ◆ max_size()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_type std::deque< _Tp, _Alloc >::max_size | ( |  | ) | const
| inlinenodiscardnoexcept

Returns the size() of the largest possible deque.

Definition at line 1340 of file stl_deque.h.

Referenced by _M_new_elements_at_back(), _M_new_elements_at_front(), _M_push_back_aux(), _M_push_front_aux(), and _M_reallocate_map().

## ◆ operator=() [1/3]

template<typename _Tp, typename _Alloc>

deque< _Tp, _Alloc > & deque::operator= | ( | const deque< _Tp, _Alloc > & | __x | ) |

Deque assignment operator.

Parameters

  __x | A deque of identical element and allocator types.

All the elements of x are copied.

The newly-created deque uses a copy of the allocator object used by __x (unless the allocator traits dictate a different object).

Definition at line 95 of file deque.tcc.

References deque(), std::__addressof(), begin(), end(), get_allocator(), size(), and std::size().

## ◆ operator=() [2/3]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

deque & std::deque< _Tp, _Alloc >::operator= | ( | deque< _Tp, _Alloc > && | __x | ) |
| inlinenoexcept

Deque move assignment operator.

Parameters

  __x | A deque of identical element and allocator types.

The contents of __x are moved into this deque (without copying, if the allocators permit it). __x is a valid, but unspecified deque.

Definition at line 1066 of file stl_deque.h.

## ◆ operator=() [3/3]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

deque & std::deque< _Tp, _Alloc >::operator= | ( | initializer_list< value_type > | __l | ) |
| inline

Assigns an initializer list to a deque.

Parameters

  __l | An initializer_list.

This function fills a deque with copies of the elements in the initializer_list __l.

Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned.

Definition at line 1085 of file stl_deque.h.

## ◆ operator[]() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::deque< _Tp, _Alloc >::operator[] | ( | size_type | __n | ) | const
| inlinenodiscardnoexcept

Subscript access to the data contained in the deque.

Parameters

  __n | The index of the element for which data should be accessed.

Returns
  Read-only (constant) reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 1449 of file stl_deque.h.

## ◆ operator[]() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::deque< _Tp, _Alloc >::operator[] | ( | size_type | __n | ) |
| inlinenodiscardnoexcept

Subscript access to the data contained in the deque.

Parameters

  __n | The index of the element for which data should be accessed.

Returns
  Read/write reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 1430 of file stl_deque.h.

## ◆ pop_back()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::pop_back | ( |  | ) |
| inlinenoexcept

Removes last element.

This is a typical stack operation. It shrinks the deque by one.

Note that no data is returned, and if the last element's data is needed, it should be retrieved before pop_back() is called.

Definition at line 1663 of file stl_deque.h.

## ◆ pop_front()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::pop_front | ( |  | ) |
| inlinenoexcept

Removes first element.

This is a typical stack operation. It shrinks the deque by one.

Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop_front() is called.

Definition at line 1640 of file stl_deque.h.

## ◆ push_back() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::push_back | ( | const value_type & | __x | ) |
| inline

Add data to the end of the deque.

Parameters

  __x | Data to be added.

This is a typical stack operation. The function creates an element at the end of the deque and assigns the given data to it. Due to the nature of a deque this operation can be done in constant time.

Definition at line 1604 of file stl_deque.h.

Referenced by _M_range_initialize(), and insert().

## ◆ push_back() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::push_back | ( | value_type && | __x | ) |
| inline

Definition at line 1619 of file stl_deque.h.

## ◆ push_front() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::push_front | ( | const value_type & | __x | ) |
| inline

Add data to the front of the deque.

Parameters

  __x | Data to be added.

This is a typical stack operation. The function creates an element at the front of the deque and assigns the given data to it. Due to the nature of a deque this operation can be done in constant time.

Definition at line 1567 of file stl_deque.h.

Referenced by insert().

## ◆ push_front() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::push_front | ( | value_type && | __x | ) |
| inline

Definition at line 1582 of file stl_deque.h.

## ◆ rbegin() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::deque< _Tp, _Alloc >::rbegin | ( |  | ) | const
| inlinenodiscardnoexcept

Returns a read-only (constant) reverse iterator that points to the last element in the deque. Iteration is done in reverse element order.

Definition at line 1261 of file stl_deque.h.

## ◆ rbegin() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reverse_iterator std::deque< _Tp, _Alloc >::rbegin | ( |  | ) |
| inlinenodiscardnoexcept

Returns a read/write reverse iterator that points to the last element in the deque. Iteration is done in reverse element order.

Definition at line 1251 of file stl_deque.h.

## ◆ rend() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::deque< _Tp, _Alloc >::rend | ( |  | ) | const
| inlinenodiscardnoexcept

Returns a read-only (constant) reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order.

Definition at line 1281 of file stl_deque.h.

## ◆ rend() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reverse_iterator std::deque< _Tp, _Alloc >::rend | ( |  | ) |
| inlinenodiscardnoexcept

Returns a read/write reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order.

Definition at line 1271 of file stl_deque.h.

## ◆ resize() [1/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::resize | ( | size_type | __new_size | ) |
| inline

Resizes the deque to the specified number of elements.

Parameters

  __new_size | Number of elements the deque should contain.

This function will resize the deque to the specified number of elements. If the number is smaller than the deque's current size the deque is truncated, otherwise default constructed elements are appended.

Definition at line 1354 of file stl_deque.h.

## ◆ resize() [2/2]

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::resize | ( | size_type | __new_size,
|  | const value_type & | __x )
| inline

Resizes the deque to the specified number of elements.

Parameters

  __new_size | Number of elements the deque should contain.
  __x | Data with which new elements should be populated.

This function will resize the deque to the specified number of elements. If the number is smaller than the deque's current size the deque is truncated, otherwise the deque is extended and new elements are populated with given data.

Definition at line 1376 of file stl_deque.h.

## ◆ shrink_to_fit()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::shrink_to_fit | ( |  | ) |
| inlinenoexcept

A non-binding request to reduce memory use.

Definition at line 1404 of file stl_deque.h.

## ◆ size()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_type std::deque< _Tp, _Alloc >::size | ( |  | ) | const
| inlinenodiscardnoexcept

Returns the number of elements in the deque.

Definition at line 1329 of file stl_deque.h.

Referenced by std::deque< _Tp, polymorphic_allocator< _Tp > >::_M_range_check(), std::operator<=>(), operator=(), std::deque< _Tp, polymorphic_allocator< _Tp > >::resize(), and std::deque< _Tp, polymorphic_allocator< _Tp > >::resize().

## ◆ swap()

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::swap | ( | deque< _Tp, _Alloc > & | __x | ) |
| inlinenoexcept

Swaps data with another deque.

Parameters

  __x | A deque of the same element and allocator types.

This exchanges the elements between two deques in constant time. (Four pointers, so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(d1,d2) will feed to this function.

Whether the allocators are swapped depends on the allocator traits.

Definition at line 1915 of file stl_deque.h.

The documentation for this class was generated from the following files:

- stl_deque.h
- deque.tcc